# Footnote

![image](https://github.com/D7NAMITE/Footnote/assets/33195267/4cc336fa-71fe-4273-a7ad-ed6b85b2ecdc)


GitHub link: https://github.com/D7NAMITE/Footnote

## Overview
Footnote is the program that comapre the data from online book store(included Meb, Naiin and Ookbee) to provide the cheapest out of the selection.

## Features
- Full-tkinter based GUI
- Search the book from three source
  - Meb
  - Naiin
  - Ookbee
- Display the graphs (Ex: Histogram of Book Price, Scatterplot of the Book Price and Rating)
- Compare the book price

## Requiments
For the program to run without any problem, you'll need:
- Python version 3.10 or later version
- book.py file
- main_gui.py file
- scraper.py file
- app_image folder
- pandas library installed
- tkinter library installed
- PIL libraly installed
- Thread library installed
- Seaboen library installed
- matplotlib library installed
- time library installed
- selenium library installed

## Technical Details

### Files and classes
- book.py : Reposible for the book related work and contain book object. Contain 2 classes
  - Book : work as a book object
  - BookRelatedTools : use to manipulate the process that related to book like turn books into dataframe
- main_gui.py : Responsible for the userinterface works. Contain all the GUI and interactions. Here's where the program run
  - GUI : Contain the GUI part of the program
- scraper.py : Responsible for the scraping data from different sources and contained Facade.
  - MebSearchScraper : Use to scrape the search page of Meb..
  - NaiinSearchScraper : Use to scrape the search page of Naiin.
  - OokbeeSearchScraper : Use to scrape the search page of Ookbee.
  - SelectionScraper : scrape the individual book after the selection.
  - Facade : work as a Facade controller of the program.
### Snapshots
![image](https://raw.githubusercontent.com/D7NAMITE/Footnote/main/app_image/footnote_logo/snapshot001.PNG?token=GHSAT0AAAAAACCATTPUZ46A546MX56PZECIZC6APBQ)

![image](https://raw.githubusercontent.com/D7NAMITE/Footnote/main/app_image/footnote_logo/snapshot002.PNG?token=GHSAT0AAAAAACCATTPVSRVAN2WFTTVB6AIWZC6APDA)

![image](https://raw.githubusercontent.com/D7NAMITE/Footnote/main/app_image/footnote_logo/snapshot003.PNG?token=GHSAT0AAAAAACCATTPVJUSM3FWXKKM44DXGZC6APEA)

### Class Diagram
![image](https://raw.githubusercontent.com/D7NAMITE/Footnote/main/app_image/footnote_logo/Footnote%20UML%20Class%20diagram.png?token=GHSAT0AAAAAACCATTPUW2HH2SBVDFZY7BLSZC6AOAQ)

## Appendix
###Selenium Installation
To use the program, you'll need to install selenium library and Chrome webdriver
Steps are:
1. run pip install selenium in the terminal
2. visit https://pypi.org/project/selenium/, go to the *Drivers* click the link *Chrome*


